#!/usr/bin/env bash

set -o nounset

curl "https://git.sovransystems.com/Sovran_Systems/Software/raw/branch/main/Sovran_SystemsOS_Updater/Updater%20Source%20Files/Intro.md" |
		
	zenity --text-info \
		--title="Sovran_SystemsOS Updater" \
		--width=1000 \
		--height=700

	if [[ $? -eq 1 ]]; then
		
		exit 1

	else

	
	ssh root@localhost 'flatpak update -y' |

		zenity --progress \
			--no-cancel \
			--auto-close \
			--pulsate \
			--width=500 \
			--text="Updating Flatpaks" \
			--title="Sovran_SystemsOS Updater"
		
		if [[ $? -ne 0 ]]; then
			
			echo "Could Not Update Flatpaks -- Exiting" |
			
			zenity --text-info \
				--title="Sovran_SystemsOS Updater" \
				--width=500 \
		 
			exit 1

		fi	

	
	ssh root@localhost 'cd /etc/nixos; nix flake update' |

		zenity --progress \
			--no-cancel \
			--auto-close \
			--pulsate \
			--width=500 \
			--text="Moving Files Into Place..." \
			--title="Sovran_SystemsOS Updater"

		if [[ $? -ne 0 ]]; then
		
			echo "Could Not Update Flake -- Exiting" |
		
			zenity --text-info \
				--title="Sovran_SystemsOS Updater" \
				--width=500 \
	 
			exit 1

		fi

	ssh root@localhost 'nixos-rebuild switch --impure' |
			
		zenity --progress \
			--no-cancel \
			--auto-close \
			--pulsate \
			--width=500 \
			--text="Updating Now - In Rare Cases, It Could Take Up To 3 Hours - Please Be Patient..." \
			--title="Sovran_SystemsOS Updater"

		if [[ $? -ne 0 ]]; then
		
			echo "Could Not Update Sovran_SystemsOS -- Exiting" |
			
			zenity --text-info \
				--title="Sovran_SystemsOS Updater" \
				--width=500 \
	 
			exit 1

		fi

zenity --info \
		--ellipsize \
		--no-wrap \
		--width=500 \
		--title="Sovran_SystemsOS Updater" \
		--text="Yay Complete! Please Reboot When You Are Ready."

	fi

exit 0